<!DOCTYPE html>
<html lang="ru"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}">
<head>
    <meta charset="UTF-8">
    <title>Фильмы из фильмотеки</title>
    <style>
        .book-link {
            text-decoration: none;
        }

        .book-link:hover {
            color: #001445;
        }

        .not-enough-book {
            color: dodgerblue;
        }
    </style>
</head>
<body>
<div layout:fragment="content">

    <div>
        <hr class="hr"/>
        <h3>Поиск фильма</h3>
        <form method="POST" th:action="@{/films/search}" th:object="${filmSearchForm}">
            <div class="mt-0 row g-2">
                <div class="col-md">
                    <div class="form-floating">
                        <input name="filmTitle" type="text" class="form-control" id="filmTitle" placeholder="Название фильма">
                        <label for="filmTitle">Название фильма</label>
                    </div>
                </div>
                <div class="col-md">
                    <div class="form-floating">
                        <input name="directorFio" type="text" class="form-control" id="directorFio" placeholder="ФИО режиссёра">
                        <label for="directorFio">Режиссёр</label>
                    </div>
                </div>
                <div class="col-md">
                    <div class="form-floating">
                        <select class="form-select" name="genre" id="genre">
                            <option selected th:value="null">Выберете жанр из списка</option>
                            <option th:each="genre : ${T(com.sber.java13spring.java13springproject.film.model.Genre).values()}"
                                    th:value="${genre}" th:text="${genre.getGenreTextDisplay()}"></option>
                        </select>
                        <label for="genre">Жанр</label>
                    </div>
                </div>
                <div class="row g-2">
                    <button type="submit" class="btn btn-secondary">Найти фильм</button>
                </div>
            </div>
        </form>
    </div>
    <hr class="mt-3 hr"/>


    <h1>Все фильмы</h1>
    <div class="row" sec:authorize="isAuthenticated() && !hasRole('USER')">
        <div class="col">
            <a href="films/add"
               class="btn btn-secondary"
               role="button"
               style="float: right"
               aria-disabled="true">Добавить фильм</a>
        </div>
    </div>
    <table class="table">
        <thead>
        <tr>
            <th scope="col">Название</th>
            <th scope="col">Год премьеры</th>
            <th scope="col">Страна</th>
            <th scope="col">Жанр</th>
            <th scope="col">Режиссёр(ы)</th>
            <th scope="col"></th>
        </tr>
        </thead>
        <tbody>
        <tr th:each="film : ${films}">
            <td>
                <a class="film-link" th:href="'/films/' + ${film.getId()}"
                   th:text="${film.getFilmTitle()}"></a>
            </td>
            <td th:text="${film.getPremierYear()}"></td>
            <td th:text="${film.getCountry()}"></td>
            <td th:text="${film.getGenre().getGenreTextDisplay()}"></td>
            <td>
                <ul>
                    <li th:each="director : ${film.getDirectors()}" th:text="${director.getDirectorFio()}"></li>
                </ul>
            </td>
            <td sec:authorize="isAuthenticated() && !hasRole('USER')">
                <form enctype="multipart/form-data" style="max-width: 50vw"
                      method="POST" th:action="@{/films/{filmId}/addDirector(filmId=${film.getId()})}"
                      th:object="${addDirectorForm}">

                    <select class="form-select" name="id" id="id" required>
                        <option selected value="" disabled="disabled">Добавить режиссёра</option>
                        <option th:each="director : ${directors}" th:value="${director.getId()}" th:text="${director.getDirectorFio()}"></option>
                    </select>
                    <button type="submit" class="btn btn-light">Добавить</button>
                </form>
            </td>
            <td>
                <div sec:authorize="isAuthenticated() && (hasRole('ADMIN') || hasRole('FILMLIBRARIAN'))">
                    <a class="btn btn-sm btn-outline-success" th:href="'/films/update/' + ${film.id}">Обновить</a>
                    <a th:if="${!film.isDeleted()}" class="btn btn-sm btn-outline-danger" th:href="'/films/delete/' + ${film.id}"
                       onclick="return confirm('Вы действительно хотите удалить книгу?')">Удалить</a>
                    <a th:if="${film.isDeleted()}" class="btn btn-sm btn-outline-warning" th:href="'/films/restore/' + ${film.getId()}">Восстановить</a>
                </div>
                <a  sec:authorize="hasRole('USER')" class="btn btn-sm btn-outline-success"
                   th:href="'/rent/film/' + ${film.id}">Арендовать фильм</a>
            </td>
        </tr>

        </tbody>
    </table>
    <div>
        <nav aria-label="Pagination" th:if="${films.totalPages gt 0}">
            <ul class="pagination justify-content-center font-weight-bold">
                <li class="page-item" th:classappend="${films.number eq 0} ? 'disabled'">
                    <a class="page-link"
                       th:href="@{/films?page={id} (id=${films.number lt 2 ? 1 : films.number})}"
                       aria-label="Previous" title="Previous Page" data-toggle="tooltip">
                        <span aria-hidden="true">&laquo;</span>
                    </a>
                </li>
                <li class="page-item" th:classappend="${i eq films.number + 1} ? 'active'"
                    th:each="i : ${#numbers.sequence( 1, films.totalPages, 1)}">
                    <a class="page-link" th:href="@{/films?page={id}(id=${i})}" th:text="${i}"
                       th:title="${'Page '+ i}" data-toggle="tooltip"></a>
                </li>
                <li class="page-item" th:classappend="${films.number eq films.totalPages - 1} ? 'disabled'">
                    <a class="page-link"
                       th:href="@{/films?page={id}(id=${films.number + 2})}"
                       aria-label="Next" title="Next Page" data-toggle="tooltip">
                        <span aria-hidden="true">&raquo;</span>
                    </a>
                </li>
            </ul>
        </nav>
    </div>
</div>

</body>
</html>
